<?php
$version["common"] = "1.0.4";

/*
// Form Field Types:
//
// 1 - Text Box
// 2 - Text Area
// 3 - Hidden
*/

/*
You can add fields into the submit
news section of nphp here.

If the user wants to insert the 
value of this into his/her news they
do <Name>. So for the default subject,
it would be <NewsSubject>.

Nothing maybe called NP:ID, this is 
used internally.
*/

  $SubmitFields[0]["Description"] = "Email";
  $SubmitFields[0]["Name"] = "NewsEmail";
  $SubmitFields[0]["DefaultValue"] = EmailAd($uname);
  $SubmitFields[0]["Type"] = 1;

  $SubmitFields[1]["Description"] = "Subject";
  $SubmitFields[1]["Name"] = "NewsSubject";
  $SubmitFields[1]["DefaultValue"] = "";
  $SubmitFields[1]["Type"] = 1;

function LoadSettings(&$settings, &$descriptions, &$yesno) {
  global $SubmitFields;
  $settings = array("SiteTitle","SiteLink","DisplayLink","-","TimeOffset","AutoBuild","AutoLinkURL",
                    "EnableGlossary","EmailUpdates","EmailDateFormat","EmailAddress","-","Number_Limit","EnableHeadlines","HeadlineNumber",
                    "HeadlineDateFormat","EnableBROption","ModifyLatest",
                    "ShowDateOnce","NewsCategorys","-","DisableHTML","-","NewsFormat","HeadlineFormat","DateFormat","ShortDateFormat",
                    "-","DisableNPHP","DisableNPHPReason");

  $descriptions["SiteTitle"] = "Enter the name of your web site, this is used in the title.";
  $descriptions["SiteLink"] = "If you enter a URL for your web site a &quot;Back To ...&quot; link is created on the toolbar. If you have multiple languages this feature disappears to conserve toolbar space.";
  $descriptions["DisplayLink"] = "If you sell anything at your web site, earn money from your web site or have banners on your site you must set this to yes, otherwise it's up to you!";
  $descriptions["TimeOffset"] = "Set this to the difference in hours between you and Greenwitch Mean Time (GMT). Current GMT time is " . gmdate("H:i - l, F jS, Y");
  $descriptions["AutoBuild"] = "Automatically build the news.txt file after posting, modifying or removing news.";
  $descriptions["AutoLinkURL"] = "<b>Disabled</b>: Automatically convert URLs into hyperlinks.";
  $descriptions["EnableGlossary"] = "This enables you to tell newsPHP to search and replace. For example, replace nphp with newsPHP.";
  $descriptions["Number_Limit"] = "The number of news posts to be visible on your web site.";
  $descriptions["EnableHeadlines"] = "Automaticallys creates headlines for your news.";
  $descriptions["HeadlineNumber"] = "The number of headlines to include in your headlines file.";
  $descriptions["EnableBROption"] = "Allow the news poster the option to turn off automatically converting new lines into HTML &lt;BR&gt; tags.";
  $descriptions["ModifyLatest"] = "The number of news items you can modify.";
  $descriptions["DisableHTML"] = "Stop news posters from using HTML. This will totally strip out all HTML (excluding anything added by newsPHP).";
  $descriptions["NewsCategorys"] = "Select Yes if you want to be able to post to difference categories. Each category has it's own news text file.";

  $descriptions["ShowDateOnce"] = "Display the full date above all posts on that same day.";
  $descriptions["NewsFormat"] = "What the news will look like. You have these availiable inserts: &lt;NewsText&gt;, &lt;NewsDate&gt;";

  for($i=0;$i<count($SubmitFields);$i++)
  {
    $descriptions["NewsFormat"] .= ", &lt;" . $SubmitFields[$i]["Name"] . "&gt;";
  }

  $descriptions["HeadlineFormat"] = "If headlines are turned on this is what they will look like.";
  $descriptions["DateFormat"] = "<a href=\"#dates\">Click here</a> to see availiable inserts. This is what the full date looks like. If ShowDateOnce=1 then this is used at the top, otherwise it is used on all posts.";
  $descriptions["ShortDateFormat"] = "<a href=\"#dates\">Click here</a> to see availiable inserts. This is used if ShowDateOnce=1, this is displayed on the posts.";
  $descriptions["DisableNPHPReason"] = "This reason will appear when people try to access newsPHP if it has been disabled.";
  $descriptions["DisableNPHP"] = "Set this to yes and fill in a reason below and newsPHP will nolonger be active. The only way to reactivate is manually deleting the <i>DisableNPHP<~-~>1</i> line from the config file.";
  $descriptions["EmailUpdates"] = "Set this to yes if you want the people on your mailing list to be emailed everytime you post some news. Autobuild must be enabled.";
  $descriptions["EmailDateFormat"] = "The format of the date sent on emails. <a href=\"#dates\">Click here</a> to see availiable inserts.";
  $descriptions["EmailAddress"] = "The email address used as a reply address when newsPHP sends email.";
  $descriptions["HeadlineDateFormat"] = "The format of the date on your headlines.";

  $yesno["SiteTitle"] = 0;
  $yesno["SiteLink"] = 0;
  $yesno["DisplayLink"] = 1;
  $yesno["TimeOffset"] = 0;
  $yesno["AutoBuild"] = 1;
  $yesno["AutoLinkURL"] = 1;
  $yesno["EnableGlossary"] = 1;
  $yesno["Number_Limit"] = 0;
  $yesno["EnableHeadlines"] = 1;
  $yesno["HeadlineNumber"] = 0;
  $yesno["EnableBROption"] = 1;
  $yesno["ModifyLatest"] = 0;
  $yesno["DisableHTML"] = 1;
  $yesno["HeadlineFormat"] = 0;
  $yesno["NewsCategorys"] = 1;
  $yesno["DateFormat"] = 0;
  $yesno["ShortDateFormat"] = 0;
  $yesno["NewsFormat"] = 2;
  $yesno["ShowDateOnce"] = 1;
  $yesno["DisableNPHP"] = 1;
  $yesno["DisableNPHPReason"] = 0;
  $yesno["EmailUpdates"] = 1;
  $yesno["EmailDateFormat"] = 0;
  $yesno["EmailAddress"] = 0;
  $yesno["HeadlineDateFormat"] = 0;
}

function htmlHeader($title,$message) {
  Global $nphpConfig;

  if($message != "") {
    $message = "<FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\" COLOR=\"#FFFFFF\">" . $message;
    $message .="</FONT>";
  } else {
    $message = ShowToolbar();
  }
?>
<HTML>
<HEAD>
<TITLE><?php print($nphpConfig["SiteTitle"]); ?>: <?php print($title); ?></TITLE>
</HEAD>
<STYLE>
a.toolbar {
color: #FFFFFF;
text-decoration: underline;
font-size: 8pt;
}

td {
font-family: verdana;
font-size: 8pt;
}
</STYLE>
<body bgcolor="#C0C0C0" text="#404040" link="#040A48" vlink="#040A48" alink="#D6E5FC">

<BR>
<CENTER>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="740"><TR BGCOLOR="#040A48"><TD BGCOLOR="#040A48">

<IMG SRC="logo.gif"><BR>

<TABLE BORDER="0" CELLPADDING="4" CELLSPACING="2" WIDTH="100%">
<TR BGCOLOR="#6A6A6A"><TD BGCOLOR="#6A6A6A">

<?php
print($message);
?>

</TD></TR></TABLE>

</TD></TR></TABLE>
</CENTER>

<BR>
<CENTER>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="740"><TR BGCOLOR="#040A48"><TD BGCOLOR="#040A48">

<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="2" WIDTH="100%">
<TR>
<TD BGCOLOR="#FFFFFF">
&nbsp;
</TD></TR><TR>
<TD BGCOLOR="#C0C0C0">

<center><table border="0" width="98%"><tr><td>

<?php
}

function htmlFooter() {
?>
</table></center>
</TD>
</TR>
</td></tr>
<TR>
<TD BGCOLOR="#FFFFFF">
&nbsp;
</TD></TR>
</TABLE>
</TD></TR></TABLE>
<BR>

<A HREF="http://sheepcow.nexen.net/" TARGET="_top"><IMG SRC="http://sheepcow.nexen.net/latver.gif" border="0"></A><BR>
<FONT SIZE="1" FACE="Verdana" COLOR="#404040">
Originally based on <A HREF="http://amphibian.gagame.com/newspro/">NewsPro</A>
</FONT>

</CENTER>
</BODY>
</HTML>
<?php
}
?>