<?php
/*
Below is PHP's error handling. I recommend
leaving the number below at "1" or "0", if you 
experiance problems try settings this 
to 8, or deleting the line. 
*/
error_reporting(1);

/*
Leave this alone unless you have some problems.
If you encounter a problem where nphp's links 
aren't pointing to the correct place, replace this
with something like:
  $scripturl = "http://www.mysite.com/nphp/nphp.php"
But make sure it's the correct URL to newsPHP
*/
$scripturl = $SCRIPT_NAME;

require("funcs.php");
require("common.php");
require("notices.php");
/*
Copyright 2000 Ben O'Neill
All rights reserved.

This script is currently FREE of charge.
You may modify this script, but you may
NOT redestribute it in any way.

You may not use this script on web sites
with pornographic content, or sites with
illegal content.

If you sell things from your web site or
make money via your web (this includes
show banners) then you must display a 
link to the newsPHP web site.

The authors cannot take responsibility 
for loss of data or anything else.

Website: http://sheepcow.nexen.net/
Email:   sheepcow@planetunreal.com
*/

/*
The debug features will not reveal any
passwords. They can help if you 
experience any problems.
*/
$DebugFeatures = 1; // If you are having problems set this to 1.

/*
The length of time the cookies for logging
into newsPHP should last (in SECONDS).
*/
$CookieLast=604800;

$version["nphp"] = "1.0.5";
$buildnum["nphp"] = 1;

$allownpver = explode(".",$version["nphp"]);
$allowlibver = explode(".",$version["common"]);
$allowlangver = explode(".",$version["notices"]);

if($allownpver[1] > $allowlibver[1] OR $allownpver[0] > $allowlibver[0]) { exit("You are using an out-of-date version of the newsPHP library file. Visit the <a href=\"http://sheepcow.nexen.net\">newsPHP</a> web site for updates."); }
if($allownpver[1] > $allowlangver[1] OR $allownpver[0] > $allowlangver[0]) { exit("You are using an out-of-date version of the newsPHP language file. Visit the <a href=\"http://sheepcow.nexen.net\">newsPHP</a> web site for updates."); }

LoadConfig($nphpConfig,$nphpUsers,$nphpGlossary,$nphpCats);

ReadQuery($qstring);

if($qstring == "logout") {
  ClearCookies();
 
  htmlHeader($Messages["Section_LogOut"]);
  print($Messages["LogOut_Message"]);
  htmlFooter();
  exit;
}

if($qstring == "showconfig") {
  if($DebugFeatures) {
    $thetime = date("H:i:s");
    $thedate = date("jS F, Y");
    $gmttime = gmdate("H:i:s");
    $gmtdate = gmdate("jS F, Y");
    print("<html><body><b>server-time</b>: $thetime<br>\n<b>server-date</b>: $thedate<br>\n");
    print("<b>gmt-time</b>: $gmttime<br>\n<b>gmt-date</b>: $gmtdate<br>\n");
    print("<b>npversion</b>: " . $version["nphp"] . "<BR>\n");

    for(reset($nphpConfig); $key=key($nphpConfig); next($nphpConfig))
      print("<b>" . htmlentities($key) . "</b>: " . htmlentities($nphpConfig[$key]) . "<BR>\n");

    print("<BR>");

    for($i=0; $i<count($nphpUsers); $i++)
    {
      print("<b>User Name</b>: " .$nphpUsers[$i][0] . "<BR>\n");
      print("<b>Email</b>: " . $nphpUsers[$i][2] . "<BR>\n");
      print("<b>Permissions</b>: " . $nphpUsers[$i][3] . "<BR><BR>\n");
    }
    
  }
  else {
    print("newsPHP's debugging features have been disabled.");
  }
  exit;
}

if($qstring == "showphp") {
  if($DebugFeatures) {
    phpinfo();
    exit;
  }
  else {
    print("newsPHP's debugging features have been disabled.");
  }
  exit;
}

if($qstring == "shownewsdat") {
  if($DebugFeatures) {
    $dat = file("newsdat.txt");

    for($i=0;$i<count($dat); $i++)
    {
      print(htmlentities($dat[$i]) . "<BR>\n");
    }
  }
  else {
    print("newsPHP's debugging features have been disabled.");
  }
  exit;
}

if($qstring == "showstats")
{
  if($DebugFeatures) {
   $newsphp = file("nphp.php");
   $notices = file("notices.php");
   $common = file("common.php");
 
   $totallines = 0;
   $totalchars = 0;
   $totalwords = 0;
   
   for($i=0;$i<count($newsphp);$i++)
   {
     $totallines++;
     $totalchars = $totalchars + strlen($newsphp[$i]);
     $temp = explode(" ",$newsphp[$i]);
     $totalwords = $totalwords + count($temp);
   }
 
   for($i=0;$i<count($notices);$i++)
   {
     $totallines++;
     $totalchars = $totalchars + strlen($notices[$i]);
     $temp = explode(" ",$notices[$i]);
     $totalwords = $totalwords + count($temp);
   }
  
   for($i=0;$i<count($common);$i++)
   {
     $totallines++;
     $totalchars = $totalchars + strlen($common[$i]);
     $temp = explode(" ",$common[$i]);
     $totalwords = $totalwords + count($temp);
   }

   print("<b>Author</b>: Ben \"SheepCow\" O'Neill<BR>");
   print("<b>Contact</b>: <a href=\"mailto:sheepcow@planetunreal.com\">sheepcow@planetunreal.com</a><BR>");
   print("<BR>");
 
   print("<b>Total Characters:</b> " . $totalchars . "<BR>");
   print("<b>Total Words:</b> " . $totalwords . " [estimate]<BR>");
   print("<b>Total Lines:</b> " . $totallines . "<BR>");
   print("<BR>");
 
   print("<b>Server Software</b>: $SERVER_SOFTWARE<BR>");
   print("<b>PHP Version</b>: " . phpversion() . "<BR>");
   print("<Br>");
}
else
{
 print("newsPHP's debugging features have been disabled.");
}

   exit;
}

if($nphpConfig["DisableNPHP"]==1) {
  print("newsPHP has been disabled. Reason:<BR><B>" . $nphpConfig["DisableNPHPReason"] . "</B>");
  exit;
}

if($qstring=="firsttime" && $nphpConfig["firsttime"] == 1)
{
  htmlHeader($Messages["Sections_Settings"]);
  LoadSettings($settings,$descriptions,$yesno);

  print("<form method=post action=\"$scripturl?firsttimesave\"><table border=0 width=100%>");

  for($i=0; $i<count($settings); $i++)
  {
   if($settings[$i] != "-") { 

    if($yesno[$settings[$i]]==1) {
     if($nphpConfig[$settings[$i]]==1) { $yvalue=" checked"; $nvalue=""; } else { $yvalue=""; $nvalue=" checked"; }
     $input = "<input type=radio name=\"" . $settings[$i] . "\" value=\"1\"$yvalue> Yes <input type=radio name=\"" . $settings[$i] . "\" value=\"0\"$nvalue> No";
    } else if($yesno[$settings[$i]]==2) {
     $input = "<textarea rows=7 cols=52 name=\"" . $settings[$i] . "\">" . $nphpConfig[$settings[$i]] . "</textarea>";
    } else {
     $input = "<input type=\"text\" name=\"" . $settings[$i] . "\" size=\"25\" value=\"" . htmlentities($nphpConfig[$settings[$i]]) . "\">";
    }

    print("<tr>\n");
    print("<td><b>" . $settings[$i] . ":</b></td>\n");
    print("<td>$input<BR>" . $descriptions[$settings[$i]] . "</td>\n");
    print("</tr>\n");
   } else {
    print("<tr><td colspan=2><hr></td></tr>");
   }
  }

  print("<tr><td colspan=2><hr></td></tr>");
  print("<tr><td colspan=2>" . $Messages["Create_Admin"] . "</td></tr>");

    print("<tr>\n");
    print("<td><b>" . $Messages["UserName"] . ":</b></td>\n");
    print("<td><input type=text size=25 name=\"create_username\"></td>\n");
    print("</tr>\n");

    print("<tr>\n");
    print("<td><b>" . $Messages["Password"] . ":</b></td>\n");
    print("<td><input type=password size=25 name=\"create_password\"></td>\n");
    print("</tr>\n");

    print("<tr>\n");
    print("<td><b>" . $Messages["Email"] . ":</b></td>\n");
    print("<td><input type=text size=25 name=\"create_email\"></td>\n");
    print("</tr>\n");

  print("<tr><td colspan=2><hr></td></tr>");
  print("<tr><td colspan=2><center><input type=submit value=\"" . $Messages["Save_Settings"] . "\"> <input type=reset value=\"" . $Messages["Reset"] . "\"></center></td></tr>");
  print("<tr><td colspan=2><hr></td></tr>");
  print("</table></form>");

  print("<BR>");
  print("<B><a name=\"dates\">Availiable Date Inserts</a></B><BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>a</b></font> - am or pm<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>A</b></font> - AM or PM<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>d</b></font> - Day of the month, two digits, e.g. 01 - 31<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>D</b></font> - Day of the week in text, e.g. Mon, Tue, Fri<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>F</b></font> - Month of the year in full, e.g. January, February<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>h</b></font> - Hour, 12-hour format, e.g. 01 - 12<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>H</b></font> - Hour, 24-hour format, e.g. 00 - 23<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>g</b></font> - Hour, 12-hour format without leading 0s, e.g. 1 - 12<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>G</b></font> - Hour, 24-hour format without leading 0s, e.g, 0 - 23<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>i</b></font> - Minutes, e.g 00 - 59<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>j</b></font> - Day of the month, e.g. 1 - 31<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>l</b></font> - Day of the week in text, e.g. Friday, Tuesday<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>m</b></font> - Month in numbers, e.g. 01 - 12<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>n</b></font> - Month in numbers, e.g. 1 - 12<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>M</b></font> - Month in 3 letters, e.g. Jan, Feb<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>s</b></font> - Seconds, 00 to 59<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>S</b></font> - Ordinal prefix, e.g. th, st, nd<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>t</b></font> - Number of days in the month, e.g. 30, 31, 28<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>U</b></font> - Seconds since the epoch, e.g " . gmdate("U") . "<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>w</b></font> - Day of the week in numbers, e.g. 0 (Sunday) - 6 (Saturday)<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>y</b></font> - Year in 2 digits, e.g " . gmdate("y") . "<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>Y</b></font> - Year in 4 digits, e.g. " . gmdate("Y") . "<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>z</b></font> - Day of the year, e.g. " . gmdate("z") . "<BR>");



  htmlFooter();
  exit;
}

if($qstring=="firsttimesave" && $nphpConfig["firsttime"]==1)
{
  htmlHeader($Messages["Sections_Settings"],$Messages["GotoLogin"]);
  LoadConfig($NewConfig,$NewUsers,$NewGlossary,$NewCats);
  LoadSettings($settings,$descriptions,$yesno);


  for($i=0; $i<count($settings); $i++)
  {
    if($settings[$i]=="-") { } else {
    eval("\$NewConfig[\"" . $settings[$i] . "\"] = \$" . $settings[$i] . ";");
    }
  }

  $NewConfig["firsttime"] = 0;

  $NewUsers[0][0] = stripslashes($create_username);
  $NewUsers[0][1] = md5(stripslashes($create_password));
  $NewUsers[0][2] = stripslashes($create_email);
  $NewUsers[0][3] = 3;
  
  SaveNPConfig($NewConfig,$NewUsers,$NewGlossary,$NewCats);
  print($Messages["Firsttime_saved"]);

  htmlFooter();
  exit;
}

//> See if the user is logged on.
$mydetails = CheckLogin();

if($qstring == "submit")
{
  DisplaySubmit();
}

if($qstring == "submitsave")
{
  Add2DataBase();
}

if($qstring == "generate")
{
  BuildNewsQuick();
  htmlHeader($Messages["Sections_Build"]);
  print($Messages["Build_Built"]);
  htmlFooter();
  exit;
}

if($qstring == "userinfo")
{
  ShowUserInfo();
}

if($qstring == "userinfosave")
{
  if(isset($set_password) AND $set_password <> "")
  {
    $newpassword = md5($set_password);
    $nphpUsers[$mydetails["id"]][1] = $newpassword;
  }

  $nphpUsers[$mydetails["id"]][2] = $set_email;
  SaveNPConfig($nphpConfig,$nphpUsers,$nphpGlossary,$nphpCats);

  htmlHeader($Messages["Sections_UserInfo"]);
  print($Messages["UserInfo_Saved"]);
  htmlFooter();
  exit;
}

if($qstring=="langs" AND $lvl==3)
{
  htmlHeader($Messages["Sections_Language"]);
  LanguageSelect();
  htmlFooter();
  exit;
}

if($qstring=="langssave" AND $lvl==3)
{
  $nphpConfig["Language"] = $set_language;
  SaveNPConfig($nphpConfig,$nphpUsers,$nphpGlossary,$nphpCats);
  htmlHeader($Messages["Language_Saved"]);
  print($Messages["Languages_SavedText"]);
  htmlFooter();
  exit;
}

if($qstring=="adduser" AND $lvl==3)
{
  AddUsers();
  exit;
}

if($qstring=="saveadduser" AND $lvl==3)
{
  htmlHeader($Messages["Sections_EditUsers"]);
  if($add_username == "") { print($Messages["EditUsers_NoUserName"]); htmlFooter(); exit; }

  $add_pword=md5($add_password);

  for($i=0;$i<count($nphpUsers);$i++)
  {
   $uc++;
  }

  $nphpUsers[$uc][0] = $add_username;
  $nphpUsers[$uc][1] = $add_pword;
  $nphpUsers[$uc][2] = $add_email;
  $nphpUsers[$uc][3] = $add_level;

  SaveNPConfig($nphpConfig,$nphpUsers,$nphpGlossary,$nphpCats);
 
  print($Messages["EditUsers_UserAdded"] . stripslashes($add_username) . $Messages["EditUsers_UserAdded2"]);

  htmlFooter();
  exit;
}

if($qstring=="saveremoveuser" AND $lvl==3)
{
  htmlHeader($Messages["Sections_EditUsers"]);

  for($i=0;$i<count($nphpUsers); $i++)
  {
    if(stripslashes($nphpUsers[$i][0]) == stripslashes($remove_username))
    {
      $nphpUsers[$i][0] = "";
      break;
    }
  }

  print(stripslashes($remove_username) . $Messages["EditUsers_Removed"]);

  SaveNPConfig($nphpConfig,$nphpUsers,$nphpGlossary,$nphpCats);
  htmlFooter();
  exit;
}

if($qstring=="editgloss" AND $lvl==3)
{
  htmlHeader($Messages["Sections_Gloss"]);

  print("<FORM METHOD=\"POST\" ACTION=\"$scripturl?savegloss\"><TABLE BORDER=0>");
  print("<TR><TD><B>" . $Messages["Replace"] . "</B></TD><TD><B>" . $Messages["With"] . "</B></TD></TR>\n");

  for($i=0; $i<count($nphpGlossary);$i++)
  {
  print("<TR><TD><input type=text name=\"gloss_replace[" . $i . "]\" size=25 value=\"" . htmlentities($nphpGlossary[$i][0]) . "\"></TD><TD><input type=text name=\"gloss_with[" . $i . "]\" size=50 value=\"" . htmlentities($nphpGlossary[$i][1]) . "\"></TD></TR>\n");
  }

  $num = $i;

  print("<TR><TD><input type=text name=\"gloss_replace[" . $num . "]\" size=25></TD><TD><input type=text name=\"gloss_with[" . $num . "]\" size=50></TD></TR>\n");
  $num++;
  print("<TR><TD><input type=text name=\"gloss_replace[" . $num . "]\" size=25></TD><TD><input type=text name=\"gloss_with[" . $num . "]\" size=50></TD></TR>\n");
  $num++;
  print("<TR><TD><input type=text name=\"gloss_replace[" . $num . "]\" size=25></TD><TD><input type=text name=\"gloss_with[" . $num . "]\" size=50></TD></TR>\n");
  print("<TR><TD colspan=2><INPUT TYPE=submit VALUE=\"" . $Messages["Submit"] . "\"></TD></TR>\n");
  print("</TABLE></FORM>");

  htmlFooter();
  exit;
}

if($qstring=="savegloss" AND $lvl==3)
{
  htmlHeader($Messages["Sections_Gloss"]);

  for($i=0;$i<count($gloss_replace);$i++)
  {
//    if($gloss_replace[$i] != "" AND $gloss_with[$i] != "")
//    {
      $nphpGlossary[$i][0] = $gloss_replace[$i];
      $nphpGlossary[$i][1] = $gloss_with[$i];
//    }
  }

  SaveNPConfig($nphpConfig,$nphpUsers,$nphpGlossary,$nphpCats);

  print($Messages["Gloss_Saved"]);
  htmlFooter();
  exit;
}

if($qstring=="remove")
{
  htmlHeader($Messages["Sections_Modify"]);

  $news = file("newsdat.txt");

  if(isset($modify_start))
  {
   $start = $modify_start;
   $end = $modify_start - ($nphpConfig["ModifyLatest"]-1);
  } else {
   $start = count($news);
   $end = (count($news)-1) - ($nphpConfig["ModifyLatest"]-1);
  }

  print("<form method=post action=\"$scripturl?removesave\"><input type=hidden value=\"$start\" name=\"modify_start\"><table width=100%>");

  for($i=$start-1; $i >= $end; $i--)
  {

 if($news[$i] == "")
 {
 }
 else
 {

    $newsdata = explode("<~>",$news[$i]);

    $newssplit2 = explode(",",$newsdata[0]);
    $newsdate = date($nphpConfig["DateFormat"],mktime(intval($newssplit2[0]+$nphpConfig["TimeOffset"]),$newssplit2[1],$newssplit2[2],$newssplit2[3],$newssplit2[4],$newssplit2[5]));

    $newsoutput = eregi_replace("\[NL\]","\n",$newsdata[2]);
    $newsfile = $newsdata[3];

    if($lvl == 1)
    {
      if($newsdata[1]==$mydetails["uname"])
      {
print("<tr><td width=\"25%\" valign=\"top\"><b>" . $Messages["Date"] . ":</b></td><td>" . $newsdate . "<input type=hidden name=\"id[$i]\" value=\"" . $newssplit2[6] . "\"></td></tr>");
  $num=4;

  for($x=0;$x<count($SubmitFields);$x++)
  {
    if($SubmitFields[$x]["Type"] == 1)
    {
      print("<tr><td width=\"25%\" valign=\"middle\"><b>" . stripslashes($SubmitFields[$x]["Description"]) . ":</b></td><td><input size=\"32\" type=\"text\" name=\"" . $SubmitFields[$x]["Name"] . "[$i]\" value=\"" . stripslashes(htmlentities($newsdata[$num])) . "\"></td></tr>");
    }
    elseif($SubmitFields[$x]["Type"] == 2)
    {
      print("<tr><td width=\"25%\" valign=\"top\"><b>" . stripslashes($SubmitFields[$x]["Description"]) . ":</b></td><td><textarea name=\"" . $SubmitFields[$x]["Name"] . "[$i]\" rows=7 cols=42>" . stripslashes(htmlentities($newsdata[$num])) . "</textarea></td></tr>");
    }
    else {  }
    $num++;
  }


if($nphpConfig["NewsCategorys"]==1)
{
 $options="";
 for($d=0;$d<count($nphpCats); $d++)
 {
   if($newsfile == $nphpCats[$d][1])
   {
     $options .= "<option value=\"" . $nphpCats[$d][1] . "\" selected>" . $nphpCats[$d][0] . "</option>\n";
   } 
   else
   {
     $options .= "<option value=\"" . $nphpCats[$d][1] . "\">" . $nphpCats[$d][0] . "</option>\n";
   }
 }
 print("<tr><td width=\"25%\" valign=\"top\"><b>" . $Messages["Category"] . ":</b></td><td><select name=\"cate[$i]\">$options</select></td></tr>");
}

print("<tr><td width=\"25%\" valign=\"top\"><b>" . $Messages["News"] . ":</b></td><td><textarea name=\"message[$i]\" rows=7 cols=42>" . stripslashes(htmlentities($newsoutput)) . "</textarea></td></tr>");
print("<tr><td width=\"25%\" valign=\"top\"><b>" . $Messages["Delete"] . ":</b></td><td><input type=radio name=\"delete[$i]\" value=1> Yes <input type=radio name=\"delete[$i]\" value=0 checked> No</td></tr>");
      } else {
 
print("<tr><td width=\"25%\" valign=\"top\"><b>" . $Messages["Poster"] . ":</b></td><td>" . $newsdata[1] . "</td></tr>");
print("<tr><td width=\"25%\" valign=\"top\"><b>" . $Messages["Date"] . ":</b></td><td>" . $newsdate . "</td></tr>");
  $num=4;

  for($x=0;$x<count($SubmitFields);$x++)
  {
    print("<tr><td width=\"25%\" valign=\"middle\"><b>" . stripslashes($SubmitFields[$x]["Description"]) . ":</b></td><td>" . stripslashes(htmlentities($newsdata[$num])) . "</td></tr>");
    $num++;
  }


if($nphpConfig["NewsCategorys"]==1)
{
 $options="";
 for($d=0;$d<count($nphpCats); $d++)
 {
   if($newsfile == $nphpCats[$d][1])
   {
     $options = $nphpCats[$d][0];
   } 
 }
 print("<tr><td width=\"25%\" valign=\"top\"><b>" . $Messages["Category"] . ":</b></td><td>$options</td></tr>");
}

print("<tr><td width=\"25%\" valign=\"top\"><b>" . $Messages["News"] . ":</b></td><td>" . stripslashes($newsdata[2]) . "</td></tr>");


      }
    }
    else
    {
print("<tr><td width=\"25%\" valign=\"top\"><b>" . $Messages["Poster"] . ":</b></td><td>" . stripslashes($newsdata[1]) . "</td></tr>");
print("<tr><td width=\"25%\" valign=\"top\"><b>" . $Messages["Date"] . ":</b></td><td>" . $newsdate . "<input type=hidden name=\"id[$i]\" value=\"" . $newssplit2[6] . "\"></td></tr>");

  $num=4;

  for($x=0;$x<count($SubmitFields);$x++)
  {
    if($SubmitFields[$x]["Type"] == 1)
    {
      print("<tr><td width=\"25%\" valign=\"middle\"><b>" . stripslashes($SubmitFields[$x]["Description"]) . ":</b></td><td><input size=\"32\" type=\"text\" name=\"" . $SubmitFields[$x]["Name"] . "[$i]\" value=\"" . stripslashes(htmlentities($newsdata[$num])) . "\"></td></tr>");
    }
    elseif($SubmitFields[$x]["Type"] == 2)
    {
      print("<tr><td width=\"25%\" valign=\"top\"><b>" . stripslashes($SubmitFields[$x]["Description"]) . ":</b></td><td><textarea name=\"" . $SubmitFields[$x]["Name"] . "[$i]\" rows=7 cols=42>" . stripslashes(htmlentities($newsdata[$num])) . "</textarea></td></tr>");
    }
    else { }
    $num++;
  }

if($nphpConfig["NewsCategorys"]==1)
{
 $options="";
 for($d=0;$d<count($nphpCats); $d++)
 {
   if($newsfile == $nphpCats[$d][1])
   {
     $options .= "<option value=\"" . $nphpCats[$d][1] . "\" selected>" . $nphpCats[$d][0] . "</option>\n";
   } 
   else
   {
     $options .= "<option value=\"" . $nphpCats[$d][1] . "\">" . $nphpCats[$d][0] . "</option>\n";
   }
 }
 print("<tr><td width=\"25%\" valign=\"top\"><b>" . $Messages["Category"] . ":</b></td><td><select name=\"cate[$i]\">$options</select></td></tr>");
}

print("<tr><td width=\"25%\" valign=\"top\"><b>" . $Messages["News"] . ":</b></td><td><textarea name=\"message[$i]\" rows=7 cols=42>" . stripslashes(htmlentities($newsoutput)) . "</textarea></td></tr>");
print("<tr><td width=\"25%\" valign=\"top\"><b>" . $Messages["Delete"] . ":</b></td><td><input type=radio name=\"delete[$i]\" value=1> Yes <input type=radio name=\"delete[$i]\" value=0 checked> No</td></tr>");
    }
print("<tr><td colspan=\"2\" width=\"100%\" valign=\"top\"><hr></td></tr>");
 }
  }

  print("<tr><td colspan=\"2\" width=\"100%\" valign=\"top\"><center><input type=\"submit\" value=\"" . $Messages["Modify_SaveChanges"] . "\"></center></td></tr>");
  print("<tr><td colspan=\"2\" width=\"100%\" valign=\"top\"><hr></td></tr>");
  print("</table></form>");
  htmlFooter();
  exit;
}

if($qstring=="settings" && $lvl=3)
{
  htmlHeader($Messages["Sections_Settings"]);
  LoadSettings($settings,$descriptions,$yesno);

  print("<form method=post action=\"$scripturl?savesettings\"><table border=0 width=100%>");

  for($i=0; $i<count($settings); $i++)
  {
   if($settings[$i] != "-") { 

    if($yesno[$settings[$i]]==1) {
     if($nphpConfig[$settings[$i]]==1) { $yvalue=" checked"; $nvalue=""; } else { $yvalue=""; $nvalue=" checked"; }
     $input = "<input type=radio name=\"" . $settings[$i] . "\" value=\"1\"$yvalue> Yes <input type=radio name=\"" . $settings[$i] . "\" value=\"0\"$nvalue> No";
    } else if($yesno[$settings[$i]]==2) {
     $input = "<textarea rows=7 cols=52 name=\"" . $settings[$i] . "\">" . $nphpConfig[$settings[$i]] . "</textarea>";
    } else {
     $input = "<input type=\"text\" name=\"" . $settings[$i] . "\" size=\"25\" value=\"" . htmlentities($nphpConfig[$settings[$i]]) . "\">";
    }

    print("<tr>\n");
    print("<td valign=top><b>" . $settings[$i] . ":</b></td>\n");
    print("<td>$input<BR>" . $descriptions[$settings[$i]] . "</td>\n");
    print("</tr>\n");
   } else {
    print("<tr><td colspan=2><hr></td></tr>");
   }
  }

  print("<tr><td colspan=2><hr></td></tr>");
  print("<tr><td colspan=2><center><input type=submit value=\"" . $Messages["Save_Settings"] . "\"> <input type=reset value=\"" . $Messages["Reset"] . "\"></center></td></tr>");
  print("<tr><td colspan=2><hr></td></tr>");
  print("</table></form>");

  print("<BR>");
  print("<B><a name=\"dates\">Availiable Date Inserts</a></B><BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>a</b></font> - am or pm<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>A</b></font> - AM or PM<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>d</b></font> - Day of the month, two digits, e.g. 01 - 31<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>D</b></font> - Day of the week in text, e.g. Mon, Tue, Fri<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>F</b></font> - Month of the year in full, e.g. January, February<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>h</b></font> - Hour, 12-hour format, e.g. 01 - 12<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>H</b></font> - Hour, 24-hour format, e.g. 00 - 23<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>g</b></font> - Hour, 12-hour format without leading 0s, e.g. 1 - 12<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>G</b></font> - Hour, 24-hour format without leading 0s, e.g, 0 - 23<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>i</b></font> - Minutes, e.g 00 - 59<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>j</b></font> - Day of the month, e.g. 1 - 31<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>l</b></font> - Day of the week in text, e.g. Friday, Tuesday<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>m</b></font> - Month in numbers, e.g. 01 - 12<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>n</b></font> - Month in numbers, e.g. 1 - 12<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>M</b></font> - Month in 3 letters, e.g. Jan, Feb<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>s</b></font> - Seconds, 00 to 59<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>S</b></font> - Ordinal prefix, e.g. th, st, nd<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>t</b></font> - Number of days in the month, e.g. 30, 31, 28<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>U</b></font> - Seconds since the epoch, e.g " . gmdate("U") . "<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>w</b></font> - Day of the week in numbers, e.g. 0 (Sunday) - 6 (Saturday)<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>y</b></font> - Year in 2 digits, e.g " . gmdate("y") . "<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>Y</b></font> - Year in 4 digits, e.g. " . gmdate("Y") . "<BR>");
  print("&nbsp;&nbsp;<font color=\"#ff0000\"><b>z</b></font> - Day of the year, e.g. " . gmdate("z") . "<BR>");


  htmlFooter();
  exit;
}

if($qstring=="savesettings" && $lvl=3)
{
  htmlHeader($Messages["Sections_Settings"]);
  LoadConfig($NewConfig,$NewUsers,$NewGlossary,$NewCats);
  LoadSettings($settings,$descriptions,$yesno);


  for($i=0; $i<count($settings); $i++)
  {
    if($settings[$i]=="-") { } else {
      eval("\$NewConfig[\"" . $settings[$i] . "\"] = \$" . $settings[$i] . ";");
    }
  }

  SaveNPConfig($NewConfig,$NewUsers,$NewGlossary,$NewCats);
  print($Messages["Settings_Saved"]);

  htmlFooter();
  exit;
}

if($qstring=="removesave")
{
  $oldnews = file("newsdat.txt");
  $newsfile = fopen("newsdat.txt","w");
  $delcount=0;

    for($i=0;$i<count($oldnews);$i++)
    {
      $saved=0;
      $dump1 = explode("<~>",$oldnews[$i]);
      $dump2 = explode(",",$dump1[0]);

      $nid = $dump2[6];

      for(reset($id); $x=key($id); next($id))
      {
        if($id[$x] == $nid)
        {
          // Found the news post.
          if($delete[$x]==1)
          {
            $saved=1;
            $delcount++;
          } 
          else
          {
            $newnews = ereg_replace("\n","[NL]",$message[$x]);
            $newnews = ereg_replace("\r","",$newnews);

            if(isset($cate[$x])) { $categ = $cate[$x]; } else { $categ = "news.txt"; }

            $output = $dump1[0] . "<~>" . $dump1[1] . "<~>" . $newnews . "<~>" . $categ;

            for($y=0; $y<count($SubmitFields); $y++)
            {
              eval("\$data = \$" . $SubmitFields[$y]["Name"] . "[$x];");
              $output .="<~>" . $data;
            }
 
            $saved=1;
            fputs($newsfile,$output . "\n");
          }
        } // else leave it alone.
      }

      if($id[0] != "") {
        if($id[0] == $nid)
        {
          // Found the news post.
          if($delete[0]==1)
          {
            $saved=1;
            $delcount++;
          } 
          else
          {
            $newnews = ereg_replace("\n","[NL]",$message[0]);
            $newnews = ereg_replace("\r","",$newnews);

            if(isset($cate[0])) { $categ = $cate[0]; } else { $categ = "news.txt"; }

            $output = $dump1[0] . "<~>" . $dump1[1] . "<~>" . $newnews . "<~>" . $categ;

            for($y=0; $y<count($SubmitFields); $y++)
            {
              eval("\$data = \$" . $SubmitFields[$y]["Name"] . "[0];");
              $output .="<~>" . $data;
            }
 
            $saved=1;
            fputs($newsfile,$output . "\n");
          }
        }
      }
      
      if($saved==0)
      {
        fputs($newsfile,$oldnews[$i]);
      }
    }

  fclose($newsfile);
  htmlHeader($Messages["Sections_Modify"]);

  if($nphpConfig["AutoBuild"]==1) {
  BuildNewsQuick();
  print($delcount . " " . $Messages["Modify_Saved"]);
  } else {
  print($delcount . " " . $Messages["Modify_SavedNoAuto"]);
  }


  htmlFooter();
  exit;
}

if($qstring == "editcats" && $lvl == 3)
{
  htmlHeader($Messages["Sections_Categorys"]);

  print("<form method=post action=\"$scripturl?savecats\"><table width=100%>");

  for($i=0; $i<count($nphpCats); $i++)
  {
    print("<tr>\n");
    print("<td><b>Category Name:</b></td>\n");
    print("<td><input type=text name=\"cat_name[$i]\" value=\"" . $NPCats[$i][0] . "\" size=25></td>\n");
    print("</tr>\n");
    print("<tr>\n");
    print("<td><b>File Name:</b></td>\n");
    print("<td><input type=text name=\"cat_file[$i]\" value=\"" . $NPCats[$i][1] . "\" size=25></td>\n");
    print("</tr>\n");
    print("<tr><td colspan=2><hr></td></tr>\n");
  }

  for($a=$i,$i=0; $i<3; $i++,$a++)
  {
    print("<tr>\n");
    print("<td><b>Category Name:</b></td>\n");
    print("<td><input type=text name=\"cat_name[$a]\" value=\"\" size=25></td>\n");
    print("</tr>\n");
    print("<tr>\n");
    print("<td><b>File Name:</b></td>\n");
    print("<td><input type=text name=\"cat_file[$a]\" value=\"\" size=25></td>\n");
    print("</tr>\n");
    print("<tr><td colspan=2><hr></td></tr>\n");
  }


  print("<tr><td colspan=2><center><input type=submit value=\"" . $Messages["Submit"] . "\"></center></td></tr>");
  print("<tr><td colspan=2><hr></td></tr>");
  print("</table></form>");
  htmlFooter();
  exit;
}

if($qstring=="savecats" && $lvl==3)
{
  htmlHeader($Messages["Sections_Categorys"]);
  $catcount = 0;

  for($i=0; $i<count($cat_name); $i++)
  {
    if($cat_name[$i] != "" && $cat_file[$i] != "")
    {
      $NewCats[$catcount][0] = $cat_name[$i];

      $filename = ereg_replace(" ","_",$cat_file[$i]);

      $NewCats[$catcount][1] = $filename;
      $catcount++;
    }
  }

  SaveNPConfig($nphpConfig,$nphpUsers,$nphpGlossary,$NewCats);

  print($Messages["Categorys_Saved"]);

  htmlFooter();
  exit;
}

if($qstring=="email" && $lvl==3)
{
  htmlHeader($Messages["Email"]);

  $EmailFormat = ereg_replace("\[NL\]","\n",$nphpConfig["EmailFormat"]);

  $tags = "&lt;NewsText&gt;, &lt;NewsLinks&gt;, &lt;NewsDate&gt;, &lt;NewsPoster&gt;";

  for($i=0;$i<count($SubmitFields);$i++)
  {
    $tags .= ", &lt;" . $SubmitFields[$i]["Name"] . "&gt;";
  }

  print("<form method=post action=\"$scripturl?emailsave\"><table border=0 width=90%>");
  print("<tr><td align=right valign=top><b>" . $Messages["Email"] . " " . $Messages["Format"] . ":</b></td><td>");
  print("<textarea rows=7 name=email_format cols=42>" . $EmailFormat . "</textarea>");
  print("</td></tr>");
  print("<tr><td align=right valign=top>&nbsp;</td><td>");
  print("<input type=submit value=\"" . $Messages["Submit"] . "\">");
  print("</td></tr>");
  print("<tr><td align=right valign=top>&nbsp;</td><td>");
  print("You have the following availiable insert tags:<br>$tags");
  print("</td></tr>");
  print("</table></form>");

  print("<BR>Here is some example code to show you how to let people subscribe and unsubscribe to your list.");


  $htmldata  = htmlentities("<form method=post action=mailling.php><table border=0><tr><td align=right><b>Email:</b></td>") . "<BR>";
  $htmldata .= htmlentities("<td><input type=text name=emailad size=25></td></tr>") . "<BR>";
  $htmldata .= htmlentities("<tr><td colspan=2><center><input type=radio value=1 name=action checked> Subscribe <input type=radio value=0 name=action> Unsubscribe</center></td></tr>") . "<BR>";
  $htmldata .= htmlentities("<tr><td> </td>") . "<BR>";
  $htmldata .= htmlentities("<td><input type=submit value=Submit></td></tr></table></form>") . "<BR>";

  $htmldata2  = "<form method=post action=mailling.php><table border=0><tr><td align=right><b>Email:</b></td>";
  $htmldata2 .= "<td><input type=text name=emailad size=25></td></tr>";
  $htmldata2 .= "<tr><td colspan=2><center><input type=radio value=1 name=action checked> Subscribe <input type=radio value=0 name=action> Unsubscribe</center></td></tr>";
  $htmldata2 .= "<tr><td> </td>";
  $htmldata2 .= "<td><input type=submit value=Submit></td></tr></table></form>";

  print("<br><br>" . $htmldata . " That would look like:<br><br>" . $htmldata2);


  htmlFooter();
  exit;
}

if($qstring=="emailsave" && $lvl==3)
{
  htmlHeader($Messages["Email"]); 
  $nphpConfig["EmailFormat"] = ereg_replace("\n","[NL]",$email_format);
  SaveNPConfig($nphpConfig,$nphpUsers,$nphpGlossary,$nphpCats);
  print($Messages["Email_Saved"]);
  htmlFooter();
  exit;
}

// Once all newsPHP's stuff has been done, let's see if
// and addons want to do anything

$npDir = opendir(".");

while($fileName = readdir($npDir))
{
  $filedata = explode(".",$fileName);
  $extension = $filedata[1];
  
  if($extension=="npe")
  {
    include($fileName);
  }
}

closedir($npDir);

// If the query hasn't been set, or caught by anything above
// display the main screen.

DisplayMain();

// If this is the firsttime run then they can setup via the web.
?>